source("utils.R")



x <- read.csv("CombinedData.csv", stringsAsFactors=FALSE)


x.imp <- data.frame(id=x$X)



######## vars specific to Green
x.imp$FmrPres3 <- x$FmrPres + 1
x.imp$FmrPres3[x$Color=="Y"] <- NA
  


######## vars specific to Yellow
x.imp$FmrPres2 <- x$FmrPres + 1
x.imp$FmrPres2[x$Color=="G"] <- NA
## fix impossible data point
x.imp$FmrPres2[x.imp$FmrPres2==4] <- NA





######## vars common to Green and Yellow
x.imp$Pres <- NA    
x.imp$Pres[x$Pres == ""] <- NA
x.imp$Pres[x$Pres == "Mc"] <- 1
x.imp$Pres[x$Pres == "NV"] <- 2
x.imp$Pres[x$Pres == "Ob"] <- 3
x.imp$Pres[x$Pres == "SE"] <- 4

x.imp$EndTax <- NA 
x.imp$EndTax[x$EndTax == ""] <- NA
x.imp$EndTax[x$EndTax == "NV"] <- 1
x.imp$EndTax[x$EndTax == "No"] <- 2
x.imp$EndTax[x$EndTax == "Yes"] <- 3

x.imp$EndPotPen <- NA
x.imp$EndPotPen[x$EndPotPen == ""] <- NA
x.imp$EndPotPen[x$EndPotPen == "NV"] <- 1
x.imp$EndPotPen[x$EndPotPen == "No"] <- 2
x.imp$EndPotPen[x$EndPotPen == "Yes"] <- 3

x.imp$EndDogRace <- NA
x.imp$EndDogRace[x$EndDogRace == ""] <- NA
x.imp$EndDogRace[x$EndDogRace == "NV"] <- 1
x.imp$EndDogRace[x$EndDogRace == "No"] <- 2
x.imp$EndDogRace[x$EndDogRace == "Yes"] <- 3

x$IsVtrUSABorn[x$IsVtrUSABorn==""] <- NA
x$IsVtrUSABorn[x$IsVtrUSABorn=="No"] <- 0
x$IsVtrUSABorn <- as.numeric(x$IsVtrUSABorn)
x.imp$IsVtrUSABorn <- x$IsVtrUSABorn + 1

x.imp$Internet <- x$Internet + 1

x.imp$Housing <- x$Housing + 1


######## vars specific to Pink
x.imp$PrivRespP <- x$PrivResp
x.imp$PrivRespP[x$Color=="B"] <- NA
x.imp$PrivRespP[x.imp$PrivRespP==2] <- 1
x.imp$PrivRespP[x.imp$PrivRespP==3] <- 2
x.imp$PrivRespP[x.imp$PrivRespP==4] <- 3
x.imp$PrivRespP[x.imp$PrivRespP==5] <- 3


x.imp$WellRunP <- x$WellRun
x.imp$WellRunP[x$Color=="B"] <- NA
x.imp$WellRunP[x.imp$WellRunP==2] <- 1
x.imp$WellRunP[x.imp$WellRunP==3] <- 2
x.imp$WellRunP[x.imp$WellRunP==4] <- 3
x.imp$WellRunP[x.imp$WellRunP==5] <- 3


x.imp$DigRespP <- x$DigResp
x.imp$DigRespP[x$Color=="B"] <- NA
x.imp$DigRespP[x.imp$DigRespP==2] <- 1
x.imp$DigRespP[x.imp$DigRespP==3] <- 2
x.imp$DigRespP[x.imp$DigRespP==4] <- 3
x.imp$DigRespP[x.imp$DigRespP==5] <- 3


x.imp$KnewDoingP <- x$KnewDoing
x.imp$KnewDoingP[x$Color=="B"] <- NA
x.imp$KnewDoingP[x.imp$KnewDoingP==2] <- 1
x.imp$KnewDoingP[x.imp$KnewDoingP==3] <- 2
x.imp$KnewDoingP[x.imp$KnewDoingP==4] <- 3
x.imp$KnewDoingP[x.imp$KnewDoingP==5] <- 3


x.imp$JobPerfP <- x$JobPerf
x.imp$JobPerfP[x$Color=="B"] <- NA


######## vars specific to Blue
x.imp$PrivRespB <- x$PrivResp
x.imp$PrivRespB[x$Color=="P"] <- NA
x.imp$PrivRespB[x.imp$PrivRespB==2] <- 1
x.imp$PrivRespB[x.imp$PrivRespB==3] <- 2
x.imp$PrivRespB[x.imp$PrivRespB==4] <- 3
x.imp$PrivRespB[x.imp$PrivRespB==5] <- 3

x.imp$WellRunB <- x$WellRun
x.imp$WellRunB[x$Color=="P"] <- NA
x.imp$WellRunB[x.imp$WellRunB==2] <- 1
x.imp$WellRunB[x.imp$WellRunB==3] <- 2
x.imp$WellRunB[x.imp$WellRunB==4] <- 3
x.imp$WellRunB[x.imp$WellRunB==5] <- 3

x.imp$DigRespB <- x$DigResp
x.imp$DigRespB[x$Color=="P"] <- NA
x.imp$DigRespB[x.imp$DigRespB==2] <- 1
x.imp$DigRespB[x.imp$DigRespB==3] <- 2
x.imp$DigRespB[x.imp$DigRespB==4] <- 3
x.imp$DigRespB[x.imp$DigRespB==5] <- 3

x.imp$KnewDoingB <- x$KnewDoing
x.imp$KnewDoingB[x$Color=="P"] <- NA
x.imp$KnewDoingB[x.imp$KnewDoingB==2] <- 1
x.imp$KnewDoingB[x.imp$KnewDoingB==3] <- 2
x.imp$KnewDoingB[x.imp$KnewDoingB==4] <- 3
x.imp$KnewDoingB[x.imp$KnewDoingB==5] <- 3

x.imp$JobPerfB <- x$JobPerf
x.imp$JobPerfB[x$Color=="P"] <- NA




######## vars common to Pink and Blue
x.imp$ProbRegis <- NA
x.imp$ProbRegis[x$ProbRegis == "No"] <- 1
x.imp$ProbRegis[x$ProbRegis == "Yes"] <- 2

x.imp$ShowID <- NA
x.imp$ShowID[x$ShowID == "NO"] <- 1
x.imp$ShowID[x$ShowID == "No"] <- 1
x.imp$ShowID[x$ShowID == "Yes"] <- 2
x.imp$ShowID[x$ShowID == "NoMemory"] <- NA

x.imp$DidVote <- x$DidVote

x.imp$EqBalProb <- NA
x.imp$EqBalProb[x$EqBalProb == "No"] <- 1
x.imp$EqBalProb[x$EqBalProb == "Yes"] <- 2
x.imp$EqBalProb[x$EqBalProb == ""] <- NA

x.imp$ConfVtCnt <- x$ConfVtCnt
x.imp$ConfVtCnt[x$ConfVtCnt == ""] <- NA
x.imp$ConfVtCnt[x$ConfVtCnt == "DK"] <- 5
x.imp$ConfVtCnt <- as.numeric(x.imp$ConfVtCnt)






######## vars common to all forms
x.imp$MiniLoc <- x$MiniLoc
MiniLoc.uniq <- sort(unique(x$MiniLoc))
save(MiniLoc.uniq, file="MiniLocUnique.Rdata")
for (i in 1:length(MiniLoc.uniq)){
  x.imp$MiniLoc[x.imp$MiniLoc == MiniLoc.uniq[i]] <- i
}

x.imp$VtrHmLang <- x$VtrHmLang
x.imp$VtrHmLang[x.imp$VtrHmLang == ""] <- NA
x.imp$VtrHmLang[x.imp$VtrHmLang == "Cant" | x.imp$VtrHmLang == "Mand"] <- "CantMand"
x.imp$VtrHmLang[x.imp$VtrHmLang == "CapVe" | x.imp$VtrHmLang == "Port"] <- "CapVePort"
VtrHmLang.uniq <- sort(unique(x.imp$VtrHmLang))
save(VtrHmLang.uniq, file="VtrHmLangUnique.Rdata")
for (i in 1:length(VtrHmLang.uniq)){
  x.imp$VtrHmLang[x.imp$VtrHmLang == VtrHmLang.uniq[i]] <- i
}
x.imp$VtrHmLang <- as.numeric(x.imp$VtrHmLang)

x.imp$IsVtrFem <- x$IsVtrFem + 1

x.imp$MiniIsVtrFem <- x$MiniIsVtrFem + 1

x.imp$IsVtrHisp <- x$IsVtrHisp + 1

x.imp$MiniIsVtrHisp <- x$MiniIsVtrHisp + 1

x.imp$VtrRace <- NA
x.imp$VtrRace[x$IsVtrAsian == 1] <- 1   ## Asian
x.imp$VtrRace[x$IsVtrBlack == 1] <- 2   ## Black
x.imp$VtrRace[x$IsVtrWhite == 1] <- 3   ## White
x.imp$VtrRace[x$IsVtrOthRace == 1] <- 4 ## OthRace

x.imp$MiniVtrRace <- NA
x.imp$MiniVtrRace[x$MiniIsVtrAsian == 1] <- 1   ## Asian
x.imp$MiniVtrRace[x$MiniIsVtrBlack == 1] <- 2   ## Black
x.imp$MiniVtrRace[x$MiniIsVtrWhite == 1] <- 3   ## White
x.imp$MiniVtrRace[x$MiniIsVtrOthRace == 1] <- 4 ## OthRace

x.imp$VtrAge <- 2008 - x$VtrYrBorn
x.imp$VtrAge[x.imp$VtrAge < 18] <- NA
x.imp$VtrAge[x.imp$VtrAge <= 25] <- 1
x.imp$VtrAge[x.imp$VtrAge > 25 & x.imp$VtrAge <= 35] <- 2
x.imp$VtrAge[x.imp$VtrAge > 35 & x.imp$VtrAge <= 45] <- 3
x.imp$VtrAge[x.imp$VtrAge > 45 & x.imp$VtrAge <= 55] <- 4
x.imp$VtrAge[x.imp$VtrAge > 55] <- 5

x.imp$MiniVtrAge <- x$MiniVtrAge
x.imp$MiniVtrAge[x.imp$MiniVtrAge < 18] <- NA
x.imp$MiniVtrAge[x.imp$MiniVtrAge <= 25] <- 1
x.imp$MiniVtrAge[x.imp$MiniVtrAge > 25 & x.imp$MiniVtrAge <= 35] <- 2
x.imp$MiniVtrAge[x.imp$MiniVtrAge > 35 & x.imp$MiniVtrAge <= 45] <- 3
x.imp$MiniVtrAge[x.imp$MiniVtrAge > 45 & x.imp$MiniVtrAge <= 55] <- 4
x.imp$MiniVtrAge[x.imp$MiniVtrAge > 55] <- 5

x.imp$Educ <- x$Educ
x.imp$Educ[x.imp$Educ == 0] <- 1 ## collapse bottom 2 educ categories

x.imp$MiniColor <- NA
x.imp$MiniColor[x$MiniColor == "B"] <- 1
x.imp$MiniColor[x$MiniColor == "G"] <- 2
x.imp$MiniColor[x$MiniColor == "P"] <- 3
x.imp$MiniColor[x$MiniColor == "Y"] <- 4

x.imp$PstrUniv <- NA
x.imp$PstrUniv[x$PstrUniv == "BC"] <- 1
x.imp$PstrUniv[x$PstrUniv == "BU"] <- 2
x.imp$PstrUniv[x$PstrUniv == "BU Law"] <- 2
x.imp$PstrUniv[x$PstrUniv == "Harvard"] <- 3
x.imp$PstrUniv[x$PstrUniv == "Harvard College"] <- 3
x.imp$PstrUniv[x$PstrUniv == "Harvard GSAS"] <- 3
x.imp$PstrUniv[x$PstrUniv == "Harvard KSG"] <- 3
x.imp$PstrUniv[x$PstrUniv == "Harvard Law"] <- 3
x.imp$PstrUniv[x$PstrUniv == "MCPHS"] <- 4
x.imp$PstrUniv[x$PstrUniv == "MCPHS "] <- 4
x.imp$PstrUniv[x$PstrUniv == "MIT"] <- 5
x.imp$PstrUniv[x$PstrUniv == "MIT "] <- 5
x.imp$PstrUniv[x$PstrUniv == "Mount Ida"] <- 6
x.imp$PstrUniv[x$PstrUniv == "NELaw"] <- 7
x.imp$PstrUniv[x$PstrUniv == "Suffolk"] <- 8
x.imp$PstrUniv[x$PstrUniv == "Suffolk "] <- 8
x.imp$PstrUniv[x$PstrUniv == "Suffolk Law"] <- 8
x.imp$PstrUniv[x$PstrUniv == "Tufts"] <- 9
x.imp$PstrUniv[x$PstrUniv == "UMASS"] <- 10
x.imp$PstrUniv[x$PstrUniv == "Wellesley"] <- 11


x.imp$PstrHght <- x$PstrHghtInch
x.imp$PstrHght[x.imp$PstrHght < 55] <- NA
x.imp$PstrHght[x.imp$PstrHght > 84] <- NA
x.imp$PstrHght[x.imp$PstrHght <= 63] <- 1
x.imp$PstrHght[x.imp$PstrHght > 63 & x.imp$PstrHght <= 66] <- 2
x.imp$PstrHght[x.imp$PstrHght > 66 & x.imp$PstrHght <= 69] <- 3
x.imp$PstrHght[x.imp$PstrHght > 69 & x.imp$PstrHght <= 72] <- 4
x.imp$PstrHght[x.imp$PstrHght > 72 ] <- 5

x.imp$PstrUSABn <- x$PstrUSABn + 1

x.imp$IsPstrFem <- x$IsPstrFem + 1

x.imp$IsPstrHisp <- x$IsPstrHisp + 1

x.imp$IsPstrAsian <- x$IsPstrAsian + 1

x.imp$IsPstrBlack <- x$IsPstrBlack + 1

x.imp$IsPstrWhite <- x$IsPstrWhite + 1

x.imp$IsPstrOthRace <- x$IsPstrOthRace + 1

x.imp$PstrRace <- NA
x.imp$PstrRace[x$IsPstrAsian == 1] <- 1   ## Asian
x.imp$PstrRace[x$IsPstrBlack == 1] <- 2   ## Black
x.imp$PstrRace[x$IsPstrWhite == 1] <- 3   ## White
x.imp$PstrRace[x$IsPstrOthRace == 1] <- 4 ## OthRace

Edtotal <- x$Grade9 + x$SomeHS + x$HS + x$SomeCollege + x$AssDeg +
  x$BachDeg + x$MastDeg + x$ProfDeg + x$PhD
breaks <- c(-100, quantile((x$BachDeg + x$MastDeg + x$ProfDeg + x$PhD) / Edtotal,
                   p=c(.333, .667)), 100)
x.imp$BachDegPrecinct <- cut((x$BachDeg + x$MastDeg + x$ProfDeg + x$PhD) / Edtotal,
                             breaks=breaks, labels=FALSE)

breaks <- c(0, quantile(x$HHIncome2005,
                        p=c(.2, .4, .6, .8)), 10000000000)
x.imp$HHincomePrecinct <- cut(x$HHIncome2005,
                              breaks=breaks, labels=FALSE)



## add additional stuff for cluster sample analysis and other analyses
x.imp$TotalPop00 <- x$TotalPop00
x.imp$TotalVAP00 <- x$TotalVAP00
x.imp$WhiteVAP00 <- x$WhiteVAP00
x.imp$BlackVAP00 <- x$BlackVAP00
x.imp$HispanicVAP00 <- x$HispanicVAP00
x.imp$NatAmVAP00 <- x$NatAmVAP00
x.imp$AsianVAP00 <- x$AsianVAP00
x.imp$RemainderVAP00 <- x$TotalVAP00 - (x$WhiteVAP00 + x$BlackVAP00 +
                                        x$HispanicVAP00 + x$NatAmVAP00 +
                                        x$AsianVAP00)


vote.data <- read.csv("CoB2008GenElecAllWithVAPForCluster.csv",
                      stringsAsFactors=FALSE)
vote.data <- vote.data[1:39,]
x.imp$Name <- x$MiniLoc
x.imp <- merge(x.imp, vote.data, by="Name")

holder <- aggregate(x$MiniColor %in% c("G", "Y"),
                    by=list(Name=x.imp$Name),
                    sum)
colnames(holder)[2] <- "NumVtrsChoLoc"
x.imp <- merge(x.imp, holder, by="Name")

x.imp$VtrChoWts <- x.imp$BallotsCast / x.imp$NumVtrsChoLoc




holder <- strsplit(x$TimeArr, split=":")
x.imp$TimeArr <- NA
for (i in 1:length(holder)){
  if (length(holder[[i]] > 1)){
    x.imp$TimeArr[i] <- as.numeric(holder[[i]][1])*60 +
      as.numeric(holder[[i]][2])
  }
  cat(i, "\n")
}
holder <- strsplit(x$TimeNow, split=":")
x.imp$TimeNow <- NA
for (i in 1:length(holder)){
  if (length(holder[[i]] > 1)){
    x.imp$TimeNow[i] <- as.numeric(holder[[i]][1])*60 +
      as.numeric(holder[[i]][2])
  }
  cat("* ", i, "\n")
}
holder <- strsplit(x$MiniTime, split=":")
x.imp$MiniTime <- NA
for (i in 1:length(holder)){
  if (length(holder[[i]] > 1)){
    x.imp$MiniTime[i] <- as.numeric(holder[[i]][1])*60 +
      as.numeric(holder[[i]][2])
  }
  cat("** ", i, "\n")
}


x.imp$UnitRespChoice <- apply(!is.na(x[,31:34]), 1, sum) > 0
x.imp$UnitRespExp <- apply(!is.na(x[,19:28]), 1, sum) > 0
x.imp$UnitResp <- x.imp$UnitRespChoice | x.imp$UnitRespExp

x.imp$LocWeights <- x$SampProb

x.imp$IDNum <- paste(x$MiniIDNum, x$MiniColor, sep="")

x.imp$stratum <- x.imp$LocWeights
x.imp$stratum[x.imp$stratum < 1] <- 0

x.imp$locfpc <- x.imp$stratum




## sort by MiniLoc and MiniColor
x.imp$MiniLocCol <- as.numeric(x.imp$MiniLoc) * 10 +
  as.numeric(x.imp$MiniColor)
sort.order <- order(x.imp$MiniLocCol)
x.imp <- x.imp[sort.order,]


background.inds <- c(1:2, 51:ncol(x.imp))
x.background <- x.imp[,background.inds]
x.imp <- x.imp[,-background.inds]





## turn x.imp into a numeric matrix
x.imp.mat <- matrix(NA, nrow(x.imp), ncol(x.imp))
for (i in 1:ncol(x.imp.mat)){
  x.imp.mat[,i] <- as.numeric(x.imp[,i])
}
colnames(x.imp.mat) <- colnames(x.imp)
rownames(x.imp.mat) <- rownames(x.imp)

#drop.indic <- apply(is.na(x.imp.mat), 1, mean) == 1
#x.imp.mat <- x.imp.mat[!drop.indic,]


save(x.imp.mat, file="XimpMat.Rdata")
save(x.background, file="XBackground.Rdata")





set.seed(83283)
all.inds <- 1:nrow(x.background)
MiniLocCol.vec <- x.background[,"MiniLocCol"]
bs.ind.mat <- NULL
n.bs <- 10
for (lc in sort(unique(MiniLocCol.vec))){
  sel.inds <- all.inds[MiniLocCol.vec == lc]
  holder <- matrix(NA, length(sel.inds), n.bs) 
  for (i in 1:n.bs){
    holder[,i] <- sample(sel.inds, size=length(sel.inds), replace=TRUE)
  }
  bs.ind.mat <- rbind(bs.ind.mat, holder)
}

save(bs.ind.mat, file="BootstrapIndices.Rdata")







