library(cat)
source("utils.R")
rngseed(482382)



cols.to.keep <- c(26:34, 39, 40, 41, 44)
my.marg <- combn(1:(length(cols.to.keep)), 3)
my.marg <- rbind(my.marg, 0)
my.marg <- as.vector(my.marg)
my.marg <- my.marg[-length(my.marg)]



prior.val <- 1.0001
maxits.val <- 5000


load("XimpMat.Rdata")  ## x.imp.mat (created by DataPrep.R)
load("XimpMat.Rdata")  ## x.imp.mat (created by DataPrep.R) 
load("BootstrapIndices.Rdata") ## bs.ind.mat (created by DataPrep.R)

## create 10 bootstrap datasets
set.seed(537210)
load("PstrImp1.Rdata") ## dataframe is filled.pstr.dat.1 (from Pollster.R)
for (cname in colnames(filled.pstr.dat.1)){
  x.imp.mat[,cname] <- filled.pstr.dat.1[,cname]
}
x.imp.mat.1 <- x.imp.mat[bs.ind.mat[,1], ]
x.imp.mat.sub <- x.imp.mat[,cols.to.keep]

my.marg <- testAll3way(x.imp.mat.sub, cutoff=0.01)

x.imp.mat.sub.1 <- x.imp.mat.1[,cols.to.keep]
my.levs <- apply(x.imp.mat.sub, 2, max, na.rm=TRUE)
s <- prelim.cat(x.imp.mat.sub, levs=my.levs)
s.1 <- prelim.cat(x.imp.mat.sub.1, levs=my.levs)
theta.hat.1 <- ecm.cat(s.1, margins=my.marg,
                       prior=prior.val, maxits=maxits.val)
filled.dat.1 <- imp.cat(s, theta.hat.1)
colnames(filled.dat.1) <- colnames(x.imp.mat.sub)
rownames(filled.dat.1) <- rownames(x.imp.mat.sub)



save(filled.dat.1, file="DemogImp1.Rdata")








load("PstrImp2.Rdata") ## dataframe is filled.pstr.dat.2 (from Pollster.R)
for (cname in colnames(filled.pstr.dat.2)){
  x.imp.mat[,cname] <- filled.pstr.dat.2[,cname]
}
x.imp.mat.2 <- x.imp.mat[bs.ind.mat[,2], ]

x.imp.mat.sub <- x.imp.mat[,cols.to.keep]
x.imp.mat.sub.2 <- x.imp.mat.2[,cols.to.keep]
my.levs <- apply(x.imp.mat.sub, 2, max, na.rm=TRUE)
s <- prelim.cat(x.imp.mat.sub, levs=my.levs)
s.2 <- prelim.cat(x.imp.mat.sub.2, levs=my.levs)
theta.hat.2 <- ecm.cat(s.2, margins=my.marg,
                       prior=prior.val, maxits=maxits.val)
filled.dat.2 <- imp.cat(s, theta.hat.1)
colnames(filled.dat.2) <- colnames(x.imp.mat.sub)
rownames(filled.dat.2) <- rownames(x.imp.mat.sub)

save(filled.dat.2, file="DemogImp2.Rdata")








load("PstrImp3.Rdata") ## dataframe is filled.pstr.dat.3 (from Pollster.R)
for (cname in colnames(filled.pstr.dat.3)){
  x.imp.mat[,cname] <- filled.pstr.dat.3[,cname]
}
x.imp.mat.3 <- x.imp.mat[bs.ind.mat[,3], ]

x.imp.mat.sub <- x.imp.mat[,cols.to.keep]
x.imp.mat.sub.3 <- x.imp.mat.3[,cols.to.keep]
my.levs <- apply(x.imp.mat.sub, 2, max, na.rm=TRUE)
s <- prelim.cat(x.imp.mat.sub, levs=my.levs)
s.3 <- prelim.cat(x.imp.mat.sub.3, levs=my.levs)
theta.hat.3 <- ecm.cat(s.3, margins=my.marg,
                       prior=prior.val, maxits=maxits.val)
filled.dat.3 <- imp.cat(s, theta.hat.3)
colnames(filled.dat.3) <- colnames(x.imp.mat.sub)
rownames(filled.dat.3) <- rownames(x.imp.mat.sub)

save(filled.dat.3, file="DemogImp3.Rdata")









load("PstrImp4.Rdata") ## dataframe is filled.pstr.dat.4 (from Pollster.R)
for (cname in colnames(filled.pstr.dat.4)){
  x.imp.mat[,cname] <- filled.pstr.dat.4[,cname]
}
x.imp.mat.4 <- x.imp.mat[bs.ind.mat[,4], ]

x.imp.mat.sub <- x.imp.mat[,cols.to.keep]
x.imp.mat.sub.4 <- x.imp.mat.4[,cols.to.keep]
my.levs <- apply(x.imp.mat.sub, 2, max, na.rm=TRUE)
s <- prelim.cat(x.imp.mat.sub, levs=my.levs)
s.4 <- prelim.cat(x.imp.mat.sub.4, levs=my.levs)
theta.hat.4 <- ecm.cat(s.4, margins=my.marg,
                       prior=prior.val, maxits=maxits.val)
filled.dat.4 <- imp.cat(s, theta.hat.4)
colnames(filled.dat.4) <- colnames(x.imp.mat.sub)
rownames(filled.dat.4) <- rownames(x.imp.mat.sub)

save(filled.dat.4, file="DemogImp4.Rdata")









load("PstrImp5.Rdata") ## dataframe is filled.pstr.dat.5 (from Pollster.R)
for (cname in colnames(filled.pstr.dat.5)){
  x.imp.mat[,cname] <- filled.pstr.dat.5[,cname]
}
x.imp.mat.5 <- x.imp.mat[bs.ind.mat[,5], ]

x.imp.mat.sub <- x.imp.mat[,cols.to.keep]
x.imp.mat.sub.5 <- x.imp.mat.5[,cols.to.keep]
my.levs <- apply(x.imp.mat.sub, 2, max, na.rm=TRUE)
s <- prelim.cat(x.imp.mat.sub, levs=my.levs)
s.5 <- prelim.cat(x.imp.mat.sub.5, levs=my.levs)
theta.hat.5 <- ecm.cat(s.5, margins=my.marg,
                       prior=prior.val, maxits=maxits.val)
filled.dat.5 <- imp.cat(s, theta.hat.5)
colnames(filled.dat.5) <- colnames(x.imp.mat.sub)
rownames(filled.dat.5) <- rownames(x.imp.mat.sub)

save(filled.dat.5, file="DemogImp5.Rdata")








load("PstrImp6.Rdata") ## dataframe is filled.pstr.dat.6 (from Pollster.R)
for (cname in colnames(filled.pstr.dat.6)){
  x.imp.mat[,cname] <- filled.pstr.dat.6[,cname]
}
x.imp.mat.6 <- x.imp.mat[bs.ind.mat[,6], ]

x.imp.mat.sub <- x.imp.mat[,cols.to.keep]
x.imp.mat.sub.6 <- x.imp.mat.6[,cols.to.keep]
my.levs <- apply(x.imp.mat.sub, 2, max, na.rm=TRUE)
s <- prelim.cat(x.imp.mat.sub, levs=my.levs)
s.6 <- prelim.cat(x.imp.mat.sub.6, levs=my.levs)
theta.hat.6 <- ecm.cat(s.6, margins=my.marg,
                       prior=prior.val, maxits=maxits.val)
filled.dat.6 <- imp.cat(s, theta.hat.6)
colnames(filled.dat.6) <- colnames(x.imp.mat.sub)
rownames(filled.dat.6) <- rownames(x.imp.mat.sub)

save(filled.dat.6, file="DemogImp6.Rdata")










load("PstrImp7.Rdata") ## dataframe is filled.pstr.dat.7 (from Pollster.R)
for (cname in colnames(filled.pstr.dat.7)){
  x.imp.mat[,cname] <- filled.pstr.dat.7[,cname]
}
x.imp.mat.7 <- x.imp.mat[bs.ind.mat[,7], ]

x.imp.mat.sub <- x.imp.mat[,cols.to.keep]
x.imp.mat.sub.7 <- x.imp.mat.7[,cols.to.keep]
my.levs <- apply(x.imp.mat.sub, 2, max, na.rm=TRUE)
s <- prelim.cat(x.imp.mat.sub, levs=my.levs)
s.7 <- prelim.cat(x.imp.mat.sub.7, levs=my.levs)
theta.hat.7 <- ecm.cat(s.7, margins=my.marg,
                       prior=prior.val, maxits=maxits.val)
filled.dat.7 <- imp.cat(s, theta.hat.7)
colnames(filled.dat.7) <- colnames(x.imp.mat.sub)
rownames(filled.dat.7) <- rownames(x.imp.mat.sub)

save(filled.dat.7, file="DemogImp7.Rdata")










load("PstrImp8.Rdata") ## dataframe is filled.pstr.dat.8 (from Pollster.R)
for (cname in colnames(filled.pstr.dat.8)){
  x.imp.mat[,cname] <- filled.pstr.dat.8[,cname]
}
x.imp.mat.8 <- x.imp.mat[bs.ind.mat[,8], ]

x.imp.mat.sub <- x.imp.mat[,cols.to.keep]
x.imp.mat.sub.8 <- x.imp.mat.8[,cols.to.keep]
my.levs <- apply(x.imp.mat.sub, 2, max, na.rm=TRUE)
s <- prelim.cat(x.imp.mat.sub, levs=my.levs)
s.8 <- prelim.cat(x.imp.mat.sub.8, levs=my.levs)
theta.hat.8 <- ecm.cat(s.8, margins=my.marg,
                       prior=prior.val, maxits=maxits.val)
filled.dat.8 <- imp.cat(s, theta.hat.8)
colnames(filled.dat.8) <- colnames(x.imp.mat.sub)
rownames(filled.dat.8) <- rownames(x.imp.mat.sub)

save(filled.dat.8, file="DemogImp8.Rdata")








load("PstrImp9.Rdata") ## dataframe is filled.pstr.dat.9 (from Pollster.R)
for (cname in colnames(filled.pstr.dat.9)){
  x.imp.mat[,cname] <- filled.pstr.dat.9[,cname]
}
x.imp.mat.9 <- x.imp.mat[bs.ind.mat[,9], ]

x.imp.mat.sub <- x.imp.mat[,cols.to.keep]
x.imp.mat.sub.9 <- x.imp.mat.9[,cols.to.keep]
my.levs <- apply(x.imp.mat.sub, 2, max, na.rm=TRUE)
s <- prelim.cat(x.imp.mat.sub, levs=my.levs)
s.9 <- prelim.cat(x.imp.mat.sub.9, levs=my.levs)
theta.hat.9 <- ecm.cat(s.9, margins=my.marg,
                       prior=prior.val, maxits=maxits.val)
filled.dat.9 <- imp.cat(s, theta.hat.1)
colnames(filled.dat.9) <- colnames(x.imp.mat.sub)
rownames(filled.dat.9) <- rownames(x.imp.mat.sub)

save(filled.dat.9, file="DemogImp9.Rdata")









load("PstrImp0.Rdata") ## dataframe is filled.pstr.dat.0 (from Pollster.R)
for (cname in colnames(filled.pstr.dat.0)){
  x.imp.mat[,cname] <- filled.pstr.dat.0[,cname]
}
x.imp.mat.0 <- x.imp.mat[bs.ind.mat[,10], ]

x.imp.mat.sub <- x.imp.mat[,cols.to.keep]
x.imp.mat.sub.0 <- x.imp.mat.0[,cols.to.keep]
my.levs <- apply(x.imp.mat.sub, 2, max, na.rm=TRUE)
s <- prelim.cat(x.imp.mat.sub, levs=my.levs)
s.0 <- prelim.cat(x.imp.mat.sub.0, levs=my.levs)
theta.hat.0 <- ecm.cat(s.0, margins=my.marg,
                       prior=prior.val, maxits=maxits.val)
filled.dat.0 <- imp.cat(s, theta.hat.1)
colnames(filled.dat.0) <- colnames(x.imp.mat.sub)
rownames(filled.dat.0) <- rownames(x.imp.mat.sub)

save(filled.dat.0, file="DemogImp0.Rdata")


















