library(cat)
source("utils.R")
rngseed(23321)


load("XimpMat.Rdata")  ## x.imp.mat (created by DataPrep.R) 
load("BootstrapIndices.Rdata") ## bs.ind.mat (created by DataPrep.R)



cols.to.keep <- c(15:19, 20:24, 26, 27, 29, 31, 33, 35, 43)
cols.to.keep <- c(16:17, 19, 20:24, 26, 27, 29, 31, 33, 35,  44)

print(cbind(colnames(x.imp.mat)[cols.to.keep]))

my.marg <- combn(1:length(cols.to.keep), 2)
my.marg <- rbind(my.marg, 0)
my.marg <- as.vector(my.marg)
my.marg <- my.marg[-length(my.marg)]
prior.val <- 1.001
max.iter <- 100



## create 10 bootstrap datasets
set.seed(5027)



## dataset 1
x.imp.mat.dem <- x.imp.mat
load("DemogImp1.Rdata") ## dataframe is filled.dat.1 (from Demographics.R)
for (cname in colnames(filled.dat.1)){
  x.imp.mat.dem[,cname] <- filled.dat.1[,cname]
}

x.imp.mat.bs <- x.imp.mat[bs.ind.mat[,1], ]

x.imp.mat.dem.sub <- x.imp.mat.dem[,cols.to.keep]
x.imp.mat.sub.bs <- x.imp.mat.bs[,cols.to.keep]

my.levs <- apply(x.imp.mat.dem.sub, 2, max, na.rm=TRUE)
s <- prelim.cat(x.imp.mat.dem.sub, levs=my.levs)
s.imp <- prelim.cat(x.imp.mat.sub.bs, levs=my.levs)


cnames <- colnames(x.imp.mat.dem.sub)
rnames <- rownames(x.imp.mat.dem.sub)

theta.hat <- ecm.cat(s.imp, margins=my.marg,
                     prior=prior.val, maxits=max.iter)

filled.blue.dat <- imp.cat(s, theta.hat)
colnames(filled.blue.dat) <- cnames
rownames(filled.blue.dat) <- rnames

filled.blue.demog.dat.1 <- cbind(filled.dat.1, filled.blue.dat,
                                   x.imp.mat[,"MiniLoc"],
                                   x.imp.mat[,"MiniColor"])
colnames(filled.blue.demog.dat.1)[ncol(filled.blue.demog.dat.1)] <-
  "MiniColor"
colnames(filled.blue.demog.dat.1)[ncol(filled.blue.demog.dat.1)-1] <-
  "MiniLoc"

save(filled.blue.demog.dat.1, file="BlueDemogImp1.Rdata")




## dataset 2
x.imp.mat.dem <- x.imp.mat
load("DemogImp2.Rdata") ## dataframe is filled.dat.2 (from Demographics.R)
for (cname in colnames(filled.dat.2)){
  x.imp.mat.dem[,cname] <- filled.dat.2[,cname]
}

x.imp.mat.bs <- x.imp.mat[bs.ind.mat[,2], ]

x.imp.mat.dem.sub <- x.imp.mat.dem[,cols.to.keep]
x.imp.mat.sub.bs <- x.imp.mat.bs[,cols.to.keep]

my.levs <- apply(x.imp.mat.dem.sub, 2, max, na.rm=TRUE)
s <- prelim.cat(x.imp.mat.dem.sub, levs=my.levs)
s.imp <- prelim.cat(x.imp.mat.sub.bs, levs=my.levs)


cnames <- colnames(x.imp.mat.dem.sub)
rnames <- rownames(x.imp.mat.dem.sub)

theta.hat <- ecm.cat(s.imp, margins=my.marg,
                     prior=prior.val, maxits=max.iter)

filled.blue.dat <- imp.cat(s, theta.hat)
colnames(filled.blue.dat) <- cnames
rownames(filled.blue.dat) <- rnames

filled.blue.demog.dat.2 <- cbind(filled.dat.2, filled.blue.dat,
                                   x.imp.mat[,"MiniLoc"],
                                   x.imp.mat[,"MiniColor"])
colnames(filled.blue.demog.dat.2)[ncol(filled.blue.demog.dat.2)] <-
  "MiniColor"
colnames(filled.blue.demog.dat.2)[ncol(filled.blue.demog.dat.2)-1] <-
  "MiniLoc"

save(filled.blue.demog.dat.2, file="BlueDemogImp2.Rdata")






## dataset 3
x.imp.mat.dem <- x.imp.mat
load("DemogImp3.Rdata") ## dataframe is filled.dat.3 (from Demographics.R)
for (cname in colnames(filled.dat.3)){
  x.imp.mat.dem[,cname] <- filled.dat.3[,cname]
}
x.imp.mat.bs <- x.imp.mat[bs.ind.mat[,3], ]


x.imp.mat.dem.sub <- x.imp.mat.dem[,cols.to.keep]
x.imp.mat.sub.bs <- x.imp.mat.bs[,cols.to.keep]

my.levs <- apply(x.imp.mat.dem.sub, 2, max, na.rm=TRUE)
s <- prelim.cat(x.imp.mat.dem.sub, levs=my.levs)
s.imp <- prelim.cat(x.imp.mat.sub.bs, levs=my.levs)


cnames <- colnames(x.imp.mat.dem.sub)
rnames <- rownames(x.imp.mat.dem.sub)

theta.hat <- ecm.cat(s.imp, margins=my.marg,
                     prior=prior.val, maxits=max.iter)

filled.blue.dat <- imp.cat(s, theta.hat)
colnames(filled.blue.dat) <- cnames
rownames(filled.blue.dat) <- rnames

filled.blue.demog.dat.3 <- cbind(filled.dat.3, filled.blue.dat,
                                   x.imp.mat[,"MiniLoc"],
                                   x.imp.mat[,"MiniColor"])
colnames(filled.blue.demog.dat.3)[ncol(filled.blue.demog.dat.3)] <-
  "MiniColor"
colnames(filled.blue.demog.dat.3)[ncol(filled.blue.demog.dat.3)-1] <-
  "MiniLoc"

save(filled.blue.demog.dat.3, file="BlueDemogImp3.Rdata")





## dataset 4
x.imp.mat.dem <- x.imp.mat
load("DemogImp4.Rdata") ## dataframe is filled.dat.4 (from Demographics.R)
for (cname in colnames(filled.dat.4)){
  x.imp.mat.dem[,cname] <- filled.dat.4[,cname]
}
x.imp.mat.bs <- x.imp.mat[bs.ind.mat[,4], ]


x.imp.mat.dem.sub <- x.imp.mat.dem[,cols.to.keep]
x.imp.mat.sub.bs <- x.imp.mat.bs[,cols.to.keep]

my.levs <- apply(x.imp.mat.dem.sub, 2, max, na.rm=TRUE)
s <- prelim.cat(x.imp.mat.dem.sub, levs=my.levs)
s.imp <- prelim.cat(x.imp.mat.sub.bs, levs=my.levs)


cnames <- colnames(x.imp.mat.dem.sub)
rnames <- rownames(x.imp.mat.dem.sub)

theta.hat <- ecm.cat(s.imp, margins=my.marg,
                     prior=prior.val, maxits=max.iter)

filled.blue.dat <- imp.cat(s, theta.hat)
colnames(filled.blue.dat) <- cnames
rownames(filled.blue.dat) <- rnames

filled.blue.demog.dat.4 <- cbind(filled.dat.4, filled.blue.dat,
                                   x.imp.mat[,"MiniLoc"],
                                   x.imp.mat[,"MiniColor"])
colnames(filled.blue.demog.dat.4)[ncol(filled.blue.demog.dat.4)] <-
  "MiniColor"
colnames(filled.blue.demog.dat.4)[ncol(filled.blue.demog.dat.4)-1] <-
  "MiniLoc"

save(filled.blue.demog.dat.4, file="BlueDemogImp4.Rdata")





## dataset 5
x.imp.mat.dem <- x.imp.mat
load("DemogImp5.Rdata") ## dataframe is filled.dat.5 (from Demographics.R)
for (cname in colnames(filled.dat.5)){
  x.imp.mat.dem[,cname] <- filled.dat.5[,cname]
}
x.imp.mat.bs <- x.imp.mat[bs.ind.mat[,5], ]


x.imp.mat.dem.sub <- x.imp.mat.dem[,cols.to.keep]
x.imp.mat.sub.bs <- x.imp.mat.bs[,cols.to.keep]

my.levs <- apply(x.imp.mat.dem.sub, 2, max, na.rm=TRUE)
s <- prelim.cat(x.imp.mat.dem.sub, levs=my.levs)
s.imp <- prelim.cat(x.imp.mat.sub.bs, levs=my.levs)


cnames <- colnames(x.imp.mat.dem.sub)
rnames <- rownames(x.imp.mat.dem.sub)

theta.hat <- ecm.cat(s.imp, margins=my.marg,
                     prior=prior.val, maxits=max.iter)

filled.blue.dat <- imp.cat(s, theta.hat)
colnames(filled.blue.dat) <- cnames
rownames(filled.blue.dat) <- rnames

filled.blue.demog.dat.5 <- cbind(filled.dat.5, filled.blue.dat,
                                   x.imp.mat[,"MiniLoc"],
                                   x.imp.mat[,"MiniColor"])
colnames(filled.blue.demog.dat.5)[ncol(filled.blue.demog.dat.5)] <-
  "MiniColor"
colnames(filled.blue.demog.dat.5)[ncol(filled.blue.demog.dat.5)-1] <-
  "MiniLoc"

save(filled.blue.demog.dat.5, file="BlueDemogImp5.Rdata")




## dataset 6
x.imp.mat.dem <- x.imp.mat
load("DemogImp6.Rdata") ## dataframe is filled.dat.6 (from Demographics.R)
for (cname in colnames(filled.dat.6)){
  x.imp.mat.dem[,cname] <- filled.dat.6[,cname]
}
x.imp.mat.bs <- x.imp.mat[bs.ind.mat[,6], ]


x.imp.mat.dem.sub <- x.imp.mat.dem[,cols.to.keep]
x.imp.mat.sub.bs <- x.imp.mat.bs[,cols.to.keep]

my.levs <- apply(x.imp.mat.dem.sub, 2, max, na.rm=TRUE)
s <- prelim.cat(x.imp.mat.dem.sub, levs=my.levs)
s.imp <- prelim.cat(x.imp.mat.sub.bs, levs=my.levs)


cnames <- colnames(x.imp.mat.dem.sub)
rnames <- rownames(x.imp.mat.dem.sub)

theta.hat <- ecm.cat(s.imp, margins=my.marg,
                     prior=prior.val, maxits=max.iter)

filled.blue.dat <- imp.cat(s, theta.hat)
colnames(filled.blue.dat) <- cnames
rownames(filled.blue.dat) <- rnames

filled.blue.demog.dat.6 <- cbind(filled.dat.6, filled.blue.dat,
                                   x.imp.mat[,"MiniLoc"],
                                   x.imp.mat[,"MiniColor"])
colnames(filled.blue.demog.dat.6)[ncol(filled.blue.demog.dat.6)] <-
  "MiniColor"
colnames(filled.blue.demog.dat.6)[ncol(filled.blue.demog.dat.6)-1] <-
  "MiniLoc"

save(filled.blue.demog.dat.6, file="BlueDemogImp6.Rdata")




## dataset 7
x.imp.mat.dem <- x.imp.mat
load("DemogImp7.Rdata") ## dataframe is filled.dat.7 (from Demographics.R)
for (cname in colnames(filled.dat.7)){
  x.imp.mat.dem[,cname] <- filled.dat.7[,cname]
}
x.imp.mat.bs <- x.imp.mat[bs.ind.mat[,7], ]


x.imp.mat.dem.sub <- x.imp.mat.dem[,cols.to.keep]
x.imp.mat.sub.bs <- x.imp.mat.bs[,cols.to.keep]

my.levs <- apply(x.imp.mat.dem.sub, 2, max, na.rm=TRUE)
s <- prelim.cat(x.imp.mat.dem.sub, levs=my.levs)
s.imp <- prelim.cat(x.imp.mat.sub.bs, levs=my.levs)


cnames <- colnames(x.imp.mat.dem.sub)
rnames <- rownames(x.imp.mat.dem.sub)

theta.hat <- ecm.cat(s.imp, margins=my.marg,
                     prior=prior.val, maxits=max.iter)

filled.blue.dat <- imp.cat(s, theta.hat)
colnames(filled.blue.dat) <- cnames
rownames(filled.blue.dat) <- rnames

filled.blue.demog.dat.7 <- cbind(filled.dat.7, filled.blue.dat,
                                   x.imp.mat[,"MiniLoc"],
                                   x.imp.mat[,"MiniColor"])
colnames(filled.blue.demog.dat.7)[ncol(filled.blue.demog.dat.7)] <-
  "MiniColor"
colnames(filled.blue.demog.dat.7)[ncol(filled.blue.demog.dat.7)-1] <-
  "MiniLoc"

save(filled.blue.demog.dat.7, file="BlueDemogImp7.Rdata")




## dataset 8
x.imp.mat.dem <- x.imp.mat
load("DemogImp8.Rdata") ## dataframe is filled.dat.8 (from Demographics.R)
for (cname in colnames(filled.dat.8)){
  x.imp.mat.dem[,cname] <- filled.dat.8[,cname]
}
x.imp.mat.bs <- x.imp.mat[bs.ind.mat[,8], ]


x.imp.mat.dem.sub <- x.imp.mat.dem[,cols.to.keep]
x.imp.mat.sub.bs <- x.imp.mat.bs[,cols.to.keep]

my.levs <- apply(x.imp.mat.dem.sub, 2, max, na.rm=TRUE)
s <- prelim.cat(x.imp.mat.dem.sub, levs=my.levs)
s.imp <- prelim.cat(x.imp.mat.sub.bs, levs=my.levs)


cnames <- colnames(x.imp.mat.dem.sub)
rnames <- rownames(x.imp.mat.dem.sub)

theta.hat <- ecm.cat(s.imp, margins=my.marg,
                     prior=prior.val, maxits=max.iter)

filled.blue.dat <- imp.cat(s, theta.hat)
colnames(filled.blue.dat) <- cnames
rownames(filled.blue.dat) <- rnames

filled.blue.demog.dat.8 <- cbind(filled.dat.8, filled.blue.dat,
                                   x.imp.mat[,"MiniLoc"],
                                   x.imp.mat[,"MiniColor"])
colnames(filled.blue.demog.dat.8)[ncol(filled.blue.demog.dat.8)] <-
  "MiniColor"
colnames(filled.blue.demog.dat.8)[ncol(filled.blue.demog.dat.8)-1] <-
  "MiniLoc"

save(filled.blue.demog.dat.8, file="BlueDemogImp8.Rdata")




## dataset 9
x.imp.mat.dem <- x.imp.mat
load("DemogImp9.Rdata") ## dataframe is filled.dat.9 (from Demographics.R)
for (cname in colnames(filled.dat.9)){
  x.imp.mat.dem[,cname] <- filled.dat.9[,cname]
}
x.imp.mat.bs <- x.imp.mat[bs.ind.mat[,9], ]


x.imp.mat.dem.sub <- x.imp.mat.dem[,cols.to.keep]
x.imp.mat.sub.bs <- x.imp.mat.bs[,cols.to.keep]

my.levs <- apply(x.imp.mat.dem.sub, 2, max, na.rm=TRUE)
s <- prelim.cat(x.imp.mat.dem.sub, levs=my.levs)
s.imp <- prelim.cat(x.imp.mat.sub.bs, levs=my.levs)


cnames <- colnames(x.imp.mat.dem.sub)
rnames <- rownames(x.imp.mat.dem.sub)

theta.hat <- ecm.cat(s.imp, margins=my.marg,
                     prior=prior.val, maxits=max.iter)

filled.blue.dat <- imp.cat(s, theta.hat)
colnames(filled.blue.dat) <- cnames
rownames(filled.blue.dat) <- rnames

filled.blue.demog.dat.9 <- cbind(filled.dat.9, filled.blue.dat,
                                   x.imp.mat[,"MiniLoc"],
                                   x.imp.mat[,"MiniColor"])
colnames(filled.blue.demog.dat.9)[ncol(filled.blue.demog.dat.9)] <-
  "MiniColor"
colnames(filled.blue.demog.dat.9)[ncol(filled.blue.demog.dat.9)-1] <-
  "MiniLoc"

save(filled.blue.demog.dat.9, file="BlueDemogImp9.Rdata")




## dataset 0
x.imp.mat.dem <- x.imp.mat
load("DemogImp0.Rdata") ## dataframe is filled.dat.0 (from Demographics.R)
for (cname in colnames(filled.dat.0)){
  x.imp.mat.dem[,cname] <- filled.dat.0[,cname]
}
x.imp.mat.bs <- x.imp.mat[bs.ind.mat[,10], ]


x.imp.mat.dem.sub <- x.imp.mat.dem[,cols.to.keep]
x.imp.mat.sub.bs <- x.imp.mat.bs[,cols.to.keep]

my.levs <- apply(x.imp.mat.dem.sub, 2, max, na.rm=TRUE)
s <- prelim.cat(x.imp.mat.dem.sub, levs=my.levs)
s.imp <- prelim.cat(x.imp.mat.sub.bs, levs=my.levs)


cnames <- colnames(x.imp.mat.dem.sub)
rnames <- rownames(x.imp.mat.dem.sub)

theta.hat <- ecm.cat(s.imp, margins=my.marg,
                     prior=prior.val, maxits=max.iter)

filled.blue.dat <- imp.cat(s, theta.hat)
colnames(filled.blue.dat) <- cnames
rownames(filled.blue.dat) <- rnames

filled.blue.demog.dat.0 <- cbind(filled.dat.0, filled.blue.dat,
                                   x.imp.mat[,"MiniLoc"],
                                   x.imp.mat[,"MiniColor"])
colnames(filled.blue.demog.dat.0)[ncol(filled.blue.demog.dat.0)] <-
  "MiniColor"
colnames(filled.blue.demog.dat.0)[ncol(filled.blue.demog.dat.0)-1] <-
  "MiniLoc"

save(filled.blue.demog.dat.0, file="BlueDemogImp0.Rdata")















