## plots ID request rates by polling location and by race by polling location

## loads voter roll data
## pp.data
load("./PollingPlaceIDinactiveData.Rdata")

M <- 1001

overall.samp <- matrix(NA, 10*M, 39)
hisp.samp <- matrix(NA, 10*M, 39)
black.samp <- matrix(NA, 10*M, 39)
white.samp <- matrix(NA, 10*M, 39)
hw.samp <- matrix(NA, 10*M, 39)
bw.samp <- matrix(NA, 10*M, 39)
overlegit.samp <- matrix(NA, 10*M, 39)


legit.mean <- rep(NA, 39)


frac.black.mean <- matrix(NA, 39, 10)
frac.hisp.mean <- matrix(NA, 39, 10)
frac.asian.mean <- matrix(NA, 39, 10)
frac.white.mean <- matrix(NA, 39, 10)



for (i in 0:9){
  pinkstring <- paste("./PinkImp", i, ".csv", sep="")
  bluestring <- paste("./BlueImp", i, ".csv", sep="")
  
  pink <- read.csv(pinkstring, stringsAsFactors=FALSE)
  blue <- read.csv(bluestring, stringsAsFactors=FALSE) 

  
  
  pink.sub <- pink[,c("ShowID", "MiniLoc", "IsVtrHisp",
                      "VtrRace")]
  blue.sub <- blue[,c("ShowID", "MiniLoc", "IsVtrHisp",
                      "VtrRace")]
  colnames(pink.sub) <- c("ShowID", "MiniLoc", "IsVtrHisp",
                          "VtrRace")
  colnames(blue.sub) <- c("ShowID", "MiniLoc", "IsVtrHisp",
                          "VtrRace")


  pink.sub$IsVtrHisp <- pink.sub$IsVtrHisp == "Yes"
  pink.sub$IsVtrAfrAm <- pink.sub$VtrRace == "Black"
  pink.sub$IsVtrAsian <- pink.sub$VtrRace == "Asian"
  pink.sub$IsVtrWhite <- pink.sub$VtrRace == "White"

  blue.sub$IsVtrHisp <- blue.sub$IsVtrHisp == "Yes"
  blue.sub$IsVtrAfrAm <- blue.sub$VtrRace == "Black"
  blue.sub$IsVtrAsian <- blue.sub$VtrRace == "Asian"
  blue.sub$IsVtrWhite <- blue.sub$VtrRace == "White"

  mydata <- rbind(pink.sub, blue.sub)
  drop.indic <- mydata$IsVtrHisp == FALSE & mydata$VtrRace == "OthRace"
  mydata <- mydata[!drop.indic,]

  mydata$ShowID <- mydata$ShowID == "Yes"
  mydata$MiniLocNum <- as.numeric(as.factor(mydata$MiniLoc))


  count <- 1
  for (loc in sort(unique(mydata$MiniLocNum))){

    legit.yes <- pp.data$n.idinactive[pp.data$pp.num == loc]
    legit.frac <- legit.yes / pp.data$n.voters[pp.data$pp.num == loc]
    
    frac.black.mean[loc, i+1] <- mean(mydata$IsVtrAfrAm[mydata$MiniLocNum  == loc])
    frac.hisp.mean[loc, i+1] <- mean(mydata$IsVtrHisp[mydata$MiniLocNum  == loc])
    frac.asian.mean[loc, i+1] <- mean(mydata$IsVtrAsian[mydata$MiniLocNum  == loc])
    frac.white.mean[loc, i+1] <- mean(mydata$IsVtrWhite[mydata$MiniLocNum  == loc])
    
    ## beta(1,1) prior
    overall.yes <- sum(mydata$ShowID[mydata$MiniLocNum  == loc] == TRUE)
    overall.no <-  sum(mydata$ShowID[mydata$MiniLocNum  == loc] == FALSE)
    overall.samp[(i*M+1):((i+1)*M), count] <- rbeta(M,
                                                    overall.yes+1,
                                                    overall.no+1)
    

    overlegit.samp[(i*M+1):((i+1)*M), count] <- overall.samp[(i*M+1):((i+1)*M),
                                                             count] -
                                                               legit.frac
    
    
    hisp.yes <- sum(mydata$ShowID[mydata$MiniLocNum  == loc &
                                  mydata$IsVtrHisp] == TRUE)
    hisp.no <-  sum(mydata$ShowID[mydata$MiniLocNum  == loc &
                                  mydata$IsVtrHisp] == FALSE)
    if (hisp.yes + hisp.no > -1){
      hisp.samp[(i*M+1):((i+1)*M), count] <- rbeta(M,
                                                   hisp.yes+1,
                                                   hisp.no+1)
    }


    black.yes <- sum(mydata$ShowID[mydata$MiniLocNum  == loc &
                                  mydata$IsVtrAfrAm] == TRUE)
    black.no <-  sum(mydata$ShowID[mydata$MiniLocNum  == loc &
                                  mydata$IsVtrAfrAm] == FALSE)
    if (black.yes + black.no > -1){
      black.samp[(i*M+1):((i+1)*M), count] <- rbeta(M,
                                                    black.yes+1,
                                                    black.no+1)
    }

    white.yes <- sum(mydata$ShowID[mydata$MiniLocNum  == loc &
                                  mydata$IsVtrWhite] == TRUE)
    white.no <-  sum(mydata$ShowID[mydata$MiniLocNum  == loc &
                                  mydata$IsVtrWhite] == FALSE)
    if (white.yes + white.no > -1){
      white.samp[(i*M+1):((i+1)*M), count] <- rbeta(M,
                                                    white.yes+1,
                                                    white.no+1)
    }


    if (hisp.yes + hisp.no > -1 & white.yes + white.no > -1){
      hw.samp[(i*M+1):((i+1)*M), count] <- hisp.samp[(i*M+1):((i+1)*M), count] -
        white.samp[(i*M+1):((i+1)*M), count]
    }

    if (black.yes + black.no > -1 & white.yes + white.no > -1){
      bw.samp[(i*M+1):((i+1)*M), count] <- black.samp[(i*M+1):((i+1)*M), count] - white.samp[(i*M+1):((i+1)*M), count]
    }
    
    count <- count + 1
  } ## end loc loop

  
}

for (loc in sort(unique(mydata$MiniLocNum))){
  legit.yes <- pp.data$n.idinactive[pp.data$pp.num == loc]
  legit.mean[loc] <- legit.yes / pp.data$n.voters[pp.data$pp.num == loc]  
}


locations <- factor(paste("location", 1:39), levels=paste("location", 39:1),
                    ordered=TRUE)
overall.mean <- apply(overall.samp, 2, mean, na.rm=TRUE)
overall.lower <- apply(overall.samp, 2, quantile, prob=0.025, na.rm=TRUE)
overall.upper <- apply(overall.samp, 2, quantile, prob=0.975, na.rm=TRUE)

overlegit.mean <- apply(overlegit.samp, 2, mean, na.rm=TRUE)
overlegit.lower <- apply(overlegit.samp, 2, quantile, prob=0.025, na.rm=TRUE)
overlegit.upper <- apply(overlegit.samp, 2, quantile, prob=0.975, na.rm=TRUE)

hisp.mean <- apply(hisp.samp, 2, mean, na.rm=TRUE)
hisp.lower <- apply(hisp.samp, 2, quantile, prob=0.025, na.rm=TRUE)
hisp.upper <- apply(hisp.samp, 2, quantile, prob=0.975, na.rm=TRUE)

black.mean <- apply(black.samp, 2, mean, na.rm=TRUE)
black.lower <- apply(black.samp, 2, quantile, prob=0.025, na.rm=TRUE)
black.upper <- apply(black.samp, 2, quantile, prob=0.975, na.rm=TRUE)

white.mean <- apply(white.samp, 2, mean, na.rm=TRUE)
white.lower <- apply(white.samp, 2, quantile, prob=0.025, na.rm=TRUE)
white.upper <- apply(white.samp, 2, quantile, prob=0.975, na.rm=TRUE)

hw.mean <- apply(hw.samp, 2, mean, na.rm=TRUE)
hw.lower <- apply(hw.samp, 2, quantile, prob=0.025, na.rm=TRUE)
hw.upper <- apply(hw.samp, 2, quantile, prob=0.975, na.rm=TRUE)

bw.mean <- apply(bw.samp, 2, mean, na.rm=TRUE)
bw.lower <- apply(bw.samp, 2, quantile, prob=0.025, na.rm=TRUE)
bw.upper <- apply(bw.samp, 2, quantile, prob=0.975, na.rm=TRUE)



frac.black.mean <- apply(frac.black.mean, 1, mean)
frac.hisp.mean <- apply(frac.hisp.mean, 1, mean)
frac.asian.mean <- apply(frac.asian.mean, 1, mean)
frac.white.mean <- apply(frac.white.mean, 1, mean)


om.order <- order(overall.mean)
locations.o <- factor(paste("location", 1:39),
                      levels=paste("location", 1:39)[om.order],
                      ordered=TRUE)
l.order <- order(legit.mean)
locations.l <- factor(paste("location", 1:39),
                      levels=paste("location", 1:39)[l.order],
                      ordered=TRUE)

ol.order <- order(overlegit.mean)
locations.ol <- factor(paste("location", 1:39),
                      levels=paste("location", 1:39)[ol.order],
                      ordered=TRUE)

hm.order <- order(hisp.mean)
locations.h <- factor(paste("location", 1:39),
                      levels=paste("location", 1:39)[hm.order],
                      ordered=TRUE)

bm.order <- order(black.mean)
locations.b <- factor(paste("location", 1:39),
                      levels=paste("location", 1:39)[bm.order],
                      ordered=TRUE)

wm.order <- order(white.mean)
locations.w <- factor(paste("location", 1:39),
                      levels=paste("location", 1:39)[wm.order],
                      ordered=TRUE)

hwm.order <- order(hw.mean)
locations.hw <- factor(paste("location", 1:39),
                      levels=paste("location", 1:39)[hwm.order],
                      ordered=TRUE)

bwm.order <- order(bw.mean)
locations.bw <- factor(paste("location", 1:39),
                      levels=paste("location", 1:39)[bwm.order],
                      ordered=TRUE)


afrac.order <- order(frac.asian.mean)
locations.afrac <- factor(paste("location", 1:39),
                      levels=paste("location", 1:39)[afrac.order],
                      ordered=TRUE)

wfrac.order <- order(frac.white.mean)
locations.wfrac <- factor(paste("location", 1:39),
                      levels=paste("location", 1:39)[wfrac.order],
                      ordered=TRUE)

bfrac.order <- order(frac.black.mean)
locations.bfrac <- factor(paste("location", 1:39),
                      levels=paste("location", 1:39)[bfrac.order],
                      ordered=TRUE)

hfrac.order <- order(frac.hisp.mean)
locations.hfrac <- factor(paste("location", 1:39),
                      levels=paste("location", 1:39)[hfrac.order],
                      ordered=TRUE)


out.data <- data.frame(locations.o, locations.h, locations.b, locations.w,
                       locations.hw, locations.bw, locations.ol, locations.l,
                       locations.afrac, locations.wfrac,
                       locations.hfrac, locations.bfrac,
                       overall.mean, overall.lower, overall.upper,
                       legit.mean, frac.black.mean, frac.hisp.mean,
                       frac.asian.mean, frac.white.mean,
                       overlegit.mean, overlegit.lower, overlegit.upper,
                       hisp.mean, hisp.lower, hisp.upper,
                       black.mean, black.lower, black.upper,
                       white.mean, white.lower, white.upper,
                       hw.mean, hw.lower, hw.upper,
                       bw.mean, bw.lower, bw.upper)






## Figure 4 in the article:
pdf("InactiveIDbyRace.pdf", height=8*.8, width=10*.8)
par(mfrow=c(2,2))
lo.fit <- loess(legit.mean ~ frac.black.mean, data=out.data,
                span=0.9, degree=1, family="symmetric")
plot(out.data$frac.black.mean, out.data$legit.mean,
     xlab="Fraction Black in Sample", ylab="Fraction HAVA or Inactive",
     xlim=c(0,0.95))
abline(h=c(0.05, 0.10, 0.15, 0.20, 0.25, 0.30), col="lightgray")
abline(v=c(0.0, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9), col="lightgray")
points(out.data$frac.black.mean, out.data$legit.mean)
range <- seq(from=0, to=max(out.data$frac.black.mean), by=0.001)
holder <- data.frame(frac.black.mean=range)
lines(range, predict(lo.fit, newdata=holder), col="red", lwd=2)

lo.fit <- loess(legit.mean ~ frac.hisp.mean, data=out.data,
                span=0.9, degree=1, family="symmetric")
plot(out.data$frac.hisp.mean, out.data$legit.mean,
     xlab="Fraction Hispanic in Sample", ylab="Fraction HAVA or Inactive",
     xlim=c(0,0.35))
abline(h=c(0.05, 0.10, 0.15, 0.20, 0.25, 0.30), col="lightgray")
abline(v=c(0.0, 0.05, 0.10, 0.15, 0.20, 0.25, 0.30, 0.35), col="lightgray")
points(out.data$frac.hisp.mean, out.data$legit.mean)
range <- seq(from=0, to=max(out.data$frac.hisp.mean), by=0.001)
holder <- data.frame(frac.hisp.mean=range)
lines(range, predict(lo.fit, newdata=holder), col="red", lwd=2)


lo.fit <- loess(legit.mean ~ frac.white.mean, data=out.data,
                span=0.9, degree=1, family="symmetric")
plot(out.data$frac.white.mean, out.data$legit.mean,
     xlab="Fraction White in Sample", ylab="Fraction HAVA or Inactive",
     xlim=c(0,0.95))
abline(h=c(0.05, 0.10, 0.15, 0.20, 0.25, 0.30), col="lightgray")
abline(v=c(0.0, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9), col="lightgray")
points(out.data$frac.white.mean, out.data$legit.mean)
range <- seq(from=0, to=max(out.data$frac.white.mean), by=0.001)
holder <- data.frame(frac.white.mean=range)
lines(range, predict(lo.fit, newdata=holder), col="red", lwd=2)

lo.fit <- loess(legit.mean ~ frac.asian.mean, data=out.data,
                span=0.9, degree=1, family="symmetric")
plot(out.data$frac.asian.mean, out.data$legit.mean,
     xlab="Fraction Asian in Sample", ylab="Fraction HAVA or Inactive",
     xlim=c(0,0.35))
abline(h=c(0.05, 0.10, 0.15, 0.20, 0.25, 0.30), col="lightgray")
abline(v=c(0.0, 0.05, 0.10, 0.15, 0.20, 0.25, 0.30, 0.35), col="lightgray")
points(out.data$frac.asian.mean, out.data$legit.mean)
range <- seq(from=0, to=max(out.data$frac.asian.mean), by=0.001)
holder <- data.frame(frac.asian.mean=range)
lines(range, predict(lo.fit, newdata=holder), col="red", lwd=2)

dev.off()




library(Hmisc)

pdf("FracWhitePollingLocation.pdf", height=8, width=8)
print(
      Dotplot(locations.wfrac ~ frac.white.mean, data=out.data,
              main="Fraction of Voters Who are White",
              xlab="Fraction White",
              ylab="Polling Location",
              xlim=c(0,1))
      )

pdf("FracAsianPollingLocation.pdf", height=8, width=8)
print(
      Dotplot(locations.afrac ~ frac.asian.mean, data=out.data,
              main="Fraction of Voters Who are Asian",
              xlab="Fraction Asian",
              ylab="Polling Location",
              xlim=c(0,1))
      )

pdf("FracHispanicPollingLocation.pdf", height=8, width=8)
print(
      Dotplot(locations.hfrac ~ frac.hisp.mean, data=out.data,
              main="Fraction of Voters Who are Hispanic",
              xlab="Fraction Hispanic",
              ylab="Polling Location",
              xlim=c(0,1))
      )

pdf("FracBlackPollingLocation.pdf", height=8, width=8)
print(
      Dotplot(locations.bfrac ~ frac.black.mean, data=out.data,
              main="Fraction of Voters Who are Black",
              xlab="Fraction Black",
              ylab="Polling Location",
              xlim=c(0,1))
      )



pdf("OverallIDrequestByPollingLocation.pdf", height=8, width=8)
print(
      Dotplot(locations.o ~ Cbind(overall.mean, overall.lower, overall.upper),
        data=out.data, main="ID Request Rate by Polling Location",
        xlab="ID Request Rate", ylab="Polling Location", xlim=c(0,1))
      )
dev.off()

pdf("LegitIDrequestByPollingLocation.pdf", height=8, width=8)
print(
      Dotplot(locations.l ~ legit.mean,
        data=out.data, main="Legitimate ID Request Rate by Polling Location",
        xlab="ID Request Rate", ylab="Polling Location", xlim=c(0,1))
      )
dev.off()

pdf("OverallVsLegitIDrequestByPollingLocation.pdf", height=8, width=8)
print(
      Dotplot(locations.ol ~ Cbind(overlegit.mean, overlegit.lower,
                                   overlegit.upper),
        data=out.data, main="Overall - Legitimate ID Request Gap by Polling Location",
        xlab="ID Request Gap", ylab="Polling Location", xlim=c(-0.05,0.6),
              panel=function(x,y,...){
                panel.abline(v=0, col="darkgray")
                panel.Dotplot(x,y,...)
              }
      )
      )
dev.off()


pdf("HispIDrequestByPollingLocation.pdf", height=8, width=8)
print(
      Dotplot(locations.h ~ Cbind(hisp.mean, hisp.lower, hisp.upper),
        data=out.data, main="ID Request Rate for Hispanics by Polling Location",
        xlab="ID Request Rate", ylab="Polling Location", xlim=c(0,1))
      )
dev.off()


pdf("BlackIDrequestByPollingLocation.pdf", height=8, width=8)
print(
      Dotplot(locations.b ~ Cbind(black.mean, black.lower, black.upper),
        data=out.data, main="ID Request Rate for Blacks by Polling Location",
        xlab="ID Request Rate", ylab="Polling Location", xlim=c(0,1))
      )
dev.off()

pdf("WhiteIDrequestByPollingLocation.pdf", height=8, width=8)
print(
      Dotplot(locations.w ~ Cbind(white.mean, white.lower, white.upper),
        data=out.data, main="ID Request Rate for Whites by Polling Location",
        xlab="ID Request Rate", ylab="Polling Location", xlim=c(0,1))
      )
dev.off()

pdf("HispWhiteIDrequestGapByPollingLocation.pdf", height=8, width=8)
print(
      Dotplot(locations.hw ~ Cbind(hw.mean, hw.lower, hw.upper),
        data=out.data, main="Hisp. - White ID Request Gap by Polling Location",
        xlab="ID Request Gap", ylab="Polling Location", xlim=c(-0.85, 0.85),
                            panel=function(x,y,...){
                panel.abline(v=0, col="darkgray")
                panel.Dotplot(x,y,...)
              }
              )
      )
dev.off()

pdf("BlackWhiteIDrequestGapByPollingLocation.pdf", height=8, width=8)
print(
      Dotplot(locations.bw ~ Cbind(bw.mean, bw.lower, bw.upper),
        data=out.data, main="Black - White ID Request Gap by Polling Location",
        xlab="ID Request Gap", ylab="Polling Location", xlim=c(-0.75,0.75),
              panel=function(x,y,...){
                panel.abline(v=0, col="darkgray")
                panel.Dotplot(x,y,...)
              }
              )
      )
dev.off()

