
filepath <- "./"
#  location of the imputations

filepathsave <- "./"
#  location of the place in which the imputationList object will be saved

numImps <- 10

####  Add some basic variables before making the imputationList object
AddVars <- function(fpath, impname, nimps, choices){
  #  Each time throught this loop fixes and saves an imputation
  for(ii in 1:nimps){
    #  create the name, load the imputation
    Shrtname <- paste(impname, (ii-1), sep = "")
    Impname <- paste(fpath, Shrtname, ".Rdata", sep = "")
    load(Impname)
    allforms.ii <- eval(parse(text = Shrtname))
    Impname <- paste(fpath, Shrtname, "Aug.Rdata", sep = "")

    #  imputations have all (pink, blue, green, yellow) forms
    #      need to reduce only those relevant for analysis
    if(choices){
      ###  Isolate the rows corresponding to the choices forms
      locs.vec <- 1:(nrow(allforms.ii))
      locs.use <- locs.vec[allforms.ii$MiniColor == "G"]
      locs.use <- c(locs.use, locs.vec[allforms.ii$MiniColor == "Y"])
      useforms.ii <- allforms.ii[locs.use,]
      ###  Add a Yes/No/NoVote indicator for whether voted for Obama
      IsOba2Party <- ifelse(useforms.ii$Pres == "Obama", "Yes",
                            ifelse(useforms.ii$Pres == "McCain", "No", "NoVote"))
      ###  Add a vector of ones for NoVote fractions
      IsInPoll <- rep(1, nrow(useforms.ii))
      ###  Add a global race/ethincity variable, must be one of the
      ###      following:  Asian, Hisp, Black, White
      VtrEthRace <- ifelse(useforms.ii$VtrRace == "Asian", "Asian",
        ifelse(useforms.ii$IsVtrHisp == "Yes","Hisp", useforms.ii$VtrRace))
      for(ii in 1:nrow(useforms.ii)){
        if(VtrEthRace[ii] == "OthRace"){
          VtrEthRace[ii] <- sample(c("Asian", "Black", "Hisp", "White"), 1, prob = c(.055, .272, .137, .500))
        }
      }
      ###  Add a within-polling location weight variable, called an fpc
      Vtrfpc <- useforms.ii$NumVtrsChoLoc/useforms.ii$BallotsCast
      ###  Write this imputation to the disk
      script <- paste(Shrtname, "Aug <- cbind(useforms.ii, IsOba2Party, IsInPoll, VtrEthRace, Vtrfpc)", sep = "")
      script <- parse(text = script)
      eval(script)
      script <- paste("save(", Shrtname, "Aug, file = Impname)", sep = "")
      script <- parse(text = script)
      eval(script)
    }
  }
}

AddVars(filepath, "ChoiceImp", 10, choices = T)
#debugging
#fpath <- filepath
#impname <- "ChoiceImp"
#nimps <- 10
#choices = T
#ii <- 1


MakeImpList <- function(fpath, impname, nimps, choices){
  #  Function to create an object of type imputationList
  #      from the mitools package for use in cluster sampling.
  #  fpath is the filepath in which the imputations are located.
  #  impname is the name given to each imputation, except for an index.
  #      The assumption is that the imputations have names impname0.Rdata,
  #      impname1.Rdata, impname2.Rdata, etc up to impname(nimps-1).Rdata.
  #  nimps is the number of multiple imputations.
  #  choices indicates whether we have choices or experience data.
  library(mitools)

  ImpList <- vector("list", nimps)  # space for list of dataframes

  #  Population ImpList with the imputations
  for(ii in 1:nimps){
    #  create the name, load the imputation
    Shrtname <- paste(impname, (ii-1), "Aug", sep = "")
    Impname <- paste(fpath, Shrtname, ".Rdata", sep = "")
    load(Impname)
    allforms.ii <- eval(parse(text = Shrtname))

    #  imputations have all (pink, blue, green, yellow) forms
    #      need to reduce only those relevant for analysis
    if(choices){
      locs.vec <- 1:(nrow(allforms.ii))
      locs.use <- locs.vec[allforms.ii$MiniColor == "G"]
      locs.use <- c(locs.use, locs.vec[allforms.ii$MiniColor == "Y"])
      useforms.ii <- allforms.ii[locs.use,]
    }
    if(!choices){
      locs.vec <- 1:(nrow(allforms.ii))
      locs.use <- c(locs.vec[allforms.ii$MiniColor == "B"],
                    locs.vec[allforms.ii$MiniColor == "P"])
      useforms.ii <- allforms.ii[locs.use,]
    }
    
    ImpList[[ii]] <- useforms.ii
  }

  #  Return an object of class imputationList from mitools
  imputationList(ImpList)
}


Choice.iL <- MakeImpList(filepath, "ChoiceImp", 10, choices = T)
save(Choice.iL, file = paste(filepathsave,
                  "Choice.iL", ".Rdata", sep = ""))



#  Choice.iL is a object of class imputationList.
#      2 elements to the list.  2d element is irrelevant
#             Choice.iL[[1]]:  list of imputations
#             Choice.iL[[1]][[1]] gives list of imputations



#attach(Choice.iL[[1]][[1]])
#WhichWt <- 2
#WhichWtVec <- (1:length(VtrChoWts))[VtrChoWts == as.data.frame(table(VtrChoWts)#)$VtrChoWts[WhichWt]]
##VtrChoWts[WhichWtVec[1]]
#ame[WhichWtVec[1]]




#  Why is MiniLoc ever != Name?
#nobs <- nrow(ChoiceImp0)
#nobsvec <- 1:nobs
#sum(ifelse(ChoiceImp0$MiniLoc == ChoiceImp0$Name, 0, 1)) # currently equals 325
#OddObs <- nobsvec[(ifelse(ChoiceImp0$MiniLoc == ChoiceImp0$Name, 0, 1)) == 1]
#ChoiceImp0[(OddObs[1:10]), ]
#table(ChoiceImp0$Name[OddObs])
#table(ChoiceImp0$MiniLoc[OddObs])


