library(cat)
source("utils.R")
rngseed(3823)
set.seed(69991)





load("XimpMat.Rdata")  ## x.imp.mat (created by DataPrep.R) 
load("BootstrapIndices.Rdata") ## bs.ind.mat (created by DataPrep.R)

## create 10 bootstrap datasets
x.imp.mat.1 <- x.imp.mat[bs.ind.mat[,1], ]
x.imp.mat.2 <- x.imp.mat[bs.ind.mat[,2], ]
x.imp.mat.3 <- x.imp.mat[bs.ind.mat[,3], ]
x.imp.mat.4 <- x.imp.mat[bs.ind.mat[,4], ]
x.imp.mat.5 <- x.imp.mat[bs.ind.mat[,5], ]
x.imp.mat.6 <- x.imp.mat[bs.ind.mat[,6], ]
x.imp.mat.7 <- x.imp.mat[bs.ind.mat[,7], ]
x.imp.mat.8 <- x.imp.mat[bs.ind.mat[,8], ]
x.imp.mat.9 <- x.imp.mat[bs.ind.mat[,9], ]
x.imp.mat.0 <- x.imp.mat[bs.ind.mat[,10], ]




cols.to.keep <- c(37, 39:41, 44)



x.imp.mat.sub <- x.imp.mat[,cols.to.keep]
x.imp.mat.sub.1 <- x.imp.mat.1[,cols.to.keep]
x.imp.mat.sub.2 <- x.imp.mat.2[,cols.to.keep]
x.imp.mat.sub.3 <- x.imp.mat.3[,cols.to.keep]
x.imp.mat.sub.4 <- x.imp.mat.4[,cols.to.keep]
x.imp.mat.sub.5 <- x.imp.mat.5[,cols.to.keep]
x.imp.mat.sub.6 <- x.imp.mat.6[,cols.to.keep]
x.imp.mat.sub.7 <- x.imp.mat.7[,cols.to.keep]
x.imp.mat.sub.8 <- x.imp.mat.8[,cols.to.keep]
x.imp.mat.sub.9 <- x.imp.mat.9[,cols.to.keep]
x.imp.mat.sub.0 <- x.imp.mat.0[,cols.to.keep]

my.levs <- apply(x.imp.mat.sub, 2, max, na.rm=TRUE)
s <- prelim.cat(x.imp.mat.sub, levs=my.levs)
s.1 <- prelim.cat(x.imp.mat.sub.1, levs=my.levs)
s.2 <- prelim.cat(x.imp.mat.sub.2, levs=my.levs)
s.3 <- prelim.cat(x.imp.mat.sub.3, levs=my.levs)
s.4 <- prelim.cat(x.imp.mat.sub.4, levs=my.levs)
s.5 <- prelim.cat(x.imp.mat.sub.5, levs=my.levs)
s.6 <- prelim.cat(x.imp.mat.sub.6, levs=my.levs)
s.7 <- prelim.cat(x.imp.mat.sub.7, levs=my.levs)
s.8 <- prelim.cat(x.imp.mat.sub.8, levs=my.levs)
s.9 <- prelim.cat(x.imp.mat.sub.9, levs=my.levs)
s.0 <- prelim.cat(x.imp.mat.sub.0, levs=my.levs)



my.marg <- combn(1:(ncol(x.imp.mat.sub)), 3)
my.marg <- rbind(my.marg, 0)
my.marg <- as.vector(my.marg)
my.marg <- my.marg[-length(my.marg)]
#my.marg <- testAll3way(x.imp.mat.sub, cutoff=0.01)

prior.val <- 1.0001
maxits.val <- 50000

theta.hat.1 <- ecm.cat(s.1, margins=my.marg,
                       prior=prior.val, maxits=maxits.val)
theta.hat.2 <- ecm.cat(s.2, margins=my.marg,  
                       prior=prior.val, maxits=maxits.val)
theta.hat.3 <- ecm.cat(s.3, margins=my.marg,  
                       prior=prior.val, maxits=maxits.val)
theta.hat.4 <- ecm.cat(s.4, margins=my.marg,  
                       prior=prior.val, maxits=maxits.val)
theta.hat.5 <- ecm.cat(s.5, margins=my.marg,  
                       prior=prior.val, maxits=maxits.val)
theta.hat.6 <- ecm.cat(s.6, margins=my.marg,  
                       prior=prior.val, maxits=maxits.val)
theta.hat.7 <- ecm.cat(s.7, margins=my.marg,  
                       prior=prior.val, maxits=maxits.val)
theta.hat.8 <- ecm.cat(s.8, margins=my.marg,  
                       prior=prior.val, maxits=maxits.val)
theta.hat.9 <- ecm.cat(s.9, margins=my.marg,  
                       prior=prior.val, maxits=maxits.val)
theta.hat.0 <- ecm.cat(s.0, margins=my.marg,  
                       prior=prior.val, maxits=maxits.val)





filled.pstr.dat.1 <- imp.cat(s, theta.hat.1)
colnames(filled.pstr.dat.1) <- colnames(x.imp.mat.sub)
rownames(filled.pstr.dat.1) <- rownames(x.imp.mat.sub)

#f <- cbind(filled.pstr.dat.1, x.imp.mat[,"MiniLoc"], x.imp.mat[,"MiniColor"])
#colnames(f)[6:7] <- c("MiniLoc", "MiniColor")
#f <- OutputRecode(f)
#stop()

filled.pstr.dat.2 <- imp.cat(s, theta.hat.2)
colnames(filled.pstr.dat.2) <- colnames(x.imp.mat.sub)
rownames(filled.pstr.dat.2) <- rownames(x.imp.mat.sub)

filled.pstr.dat.3 <- imp.cat(s, theta.hat.3)
colnames(filled.pstr.dat.3) <- colnames(x.imp.mat.sub)
rownames(filled.pstr.dat.3) <- rownames(x.imp.mat.sub)

filled.pstr.dat.4 <- imp.cat(s, theta.hat.4)
colnames(filled.pstr.dat.4) <- colnames(x.imp.mat.sub)
rownames(filled.pstr.dat.4) <- rownames(x.imp.mat.sub)

filled.pstr.dat.5 <- imp.cat(s, theta.hat.5)
colnames(filled.pstr.dat.5) <- colnames(x.imp.mat.sub)
rownames(filled.pstr.dat.5) <- rownames(x.imp.mat.sub)

filled.pstr.dat.6 <- imp.cat(s, theta.hat.6)
colnames(filled.pstr.dat.6) <- colnames(x.imp.mat.sub)
rownames(filled.pstr.dat.6) <- rownames(x.imp.mat.sub)

filled.pstr.dat.7 <- imp.cat(s, theta.hat.7)
colnames(filled.pstr.dat.7) <- colnames(x.imp.mat.sub)
rownames(filled.pstr.dat.7) <- rownames(x.imp.mat.sub)

filled.pstr.dat.8 <- imp.cat(s, theta.hat.8)
colnames(filled.pstr.dat.8) <- colnames(x.imp.mat.sub)
rownames(filled.pstr.dat.8) <- rownames(x.imp.mat.sub)

filled.pstr.dat.9 <- imp.cat(s, theta.hat.9)
colnames(filled.pstr.dat.9) <- colnames(x.imp.mat.sub)
rownames(filled.pstr.dat.9) <- rownames(x.imp.mat.sub)

filled.pstr.dat.0 <- imp.cat(s, theta.hat.0)
colnames(filled.pstr.dat.0) <- colnames(x.imp.mat.sub)
rownames(filled.pstr.dat.0) <- rownames(x.imp.mat.sub)


save(filled.pstr.dat.1, file="PstrImp1.Rdata")
save(filled.pstr.dat.2, file="PstrImp2.Rdata")
save(filled.pstr.dat.3, file="PstrImp3.Rdata")
save(filled.pstr.dat.4, file="PstrImp4.Rdata")
save(filled.pstr.dat.5, file="PstrImp5.Rdata")
save(filled.pstr.dat.6, file="PstrImp6.Rdata")
save(filled.pstr.dat.7, file="PstrImp7.Rdata")
save(filled.pstr.dat.8, file="PstrImp8.Rdata")
save(filled.pstr.dat.9, file="PstrImp9.Rdata")
save(filled.pstr.dat.0, file="PstrImp0.Rdata")












