## plot number of actual voters / number of people approached per polling loc
##
## This quantity is constant across imputations so we just need to pull 1
##   imputed dataset
##

library(lattice)


## raw (non-imputed) data 
raw <- read.csv("CombinedData.csv")



vote.data <- read.csv("CoB2008GenElecAllWithVAPForCluster.csv",
                      stringsAsFactors=FALSE)
vote.data <- vote.data[1:39,]
raw$Name <- raw$MiniLoc
x  <- merge(raw, vote.data, by="Name")

holder <- aggregate(x$MiniColor %in% c("P", "B", "G", "Y"),
                    by=list(Name=x$Name),
                    sum)
colnames(holder)[2] <- "NumVtrsLoc"



x <- merge(x, holder, by="Name")

x$VotersPerApproach <- x$BallotsCast / x$NumVtrsLoc




x <- x[,c("MiniLoc", "VotersPerApproach")]
x$MiniLocNum <- as.numeric(as.factor(x$MiniLoc))
x$loc <- paste("location", x$MiniLocNum)
x <- unique(x)

pdf("VotersPerApproach.pdf", height=8, width=8)
print(dotplot(loc ~ VotersPerApproach, data=x, xlab="Voters per Approach",
              xlim=c(6, 10),
              panel=function(x,y,...){
                panel.abline(v=8, col="darkgray")
                panel.dotplot(x,y,...)
              }
              )
      )
dev.off()
