## fitted prob calculation for table in ms
library(splines)
load("hier1.Rdata")


cong.spline.mat <- bs(0.075, knots=c(0.075, 0.125), degree=3,
                      Boundary.knots=c(0, 0.3))[,]

## row a black
x.a <- c(1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, cong.spline.mat) 

## row b hispanic
x.b <- c(1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, cong.spline.mat)

## row c white
x.c <- c(1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, cong.spline.mat)

## row d black non-english speaker
x.d <- c(1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, cong.spline.mat)

## row e hispanic non-english speaker
x.e <- c(1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, cong.spline.mat)

## row f white non-english speaker
x.f <- c(1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, cong.spline.mat) 

## row g white non-english educ >= college
x.g <- c(1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, cong.spline.mat)

## row h white educ >= college
x.h <- c(1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, cong.spline.mat)


storage <- matrix(NA, nrow(out.basic), 8)


for (iter in 1:nrow(out.basic)){
  u <- rnorm(1, m=0, s=sqrt(out.basic[iter,19]))
  storage[iter,1] <- pnorm(x.a %*% out.basic[iter, 1:16] + u)
  storage[iter,2] <- pnorm(x.b %*% out.basic[iter, 1:16] + u)
  storage[iter,3] <- pnorm(x.c %*% out.basic[iter, 1:16] + u)
  storage[iter,4] <- pnorm(x.d %*% out.basic[iter, 1:16] + u)
  storage[iter,5] <- pnorm(x.e %*% out.basic[iter, 1:16] + u)
  storage[iter,6] <- pnorm(x.f %*% out.basic[iter, 1:16] + u)
  storage[iter,7] <- pnorm(x.g %*% out.basic[iter, 1:16] + u)
  storage[iter,8] <- pnorm(x.h %*% out.basic[iter, 1:16] + u)

}


print(round(apply(storage, 2, mean), 3))

