## create plot of new sensitivity analysis based on gap between whites and
## minority voters

load("sensit.out.probit-short-gap.Rdata")

outmat <- as.data.frame(outmat)

pdf("gap-sens-plot.pdf", height=7*1.3, width=13*1.3)
par(mfrow=c(1,2))
plot(outmat$delta, outmat$beta.hisp, pch=16, ylim=c(-0.2, 0.8), type="n",
     xlab="Fraction HAVA/Inactive Among Non-Whites - Fraction HAVA/Inactive Among Whites",
     ylab="Hispanic Coefficient",
     main="Sensitivity Analysis for Hispanic Coefficient")
abline(h=0, lwd=0.5, col="gray")


lo.center <- loess(beta.hisp ~ delta, data=outmat)
lo.upper <- loess(upper.hisp ~ delta, data=outmat)
lo.lower <- loess(lower.hisp ~ delta, data=outmat)

delta.vals <- seq(from=0, to=0.2, by=0.001)
newdata <- data.frame(delta=delta.vals)

lines(delta.vals, predict(lo.center, newdata), lwd=4)
lines(delta.vals, predict(lo.upper, newdata), col="darkgray", lwd=2)
lines(delta.vals, predict(lo.lower, newdata), col="darkgray", lwd=2)






plot(outmat$delta, outmat$beta.black, pch=16, ylim=c(-0.2, 0.8), type="n",
     xlab="Fraction HAVA/Inactive Among Non-Whites - Fraction HAVA/Inactive Among Whites",
     ylab="Black Coefficient",
     main="Sensitivity Analysis for Black Coefficient")
abline(h=0, lwd=0.5, col="gray")


lo.center <- loess(beta.black ~ delta, data=outmat)
lo.upper <- loess(upper.black ~ delta, data=outmat)
lo.lower <- loess(lower.black ~ delta, data=outmat)

delta.vals <- seq(from=0, to=0.2, by=0.001)
newdata <- data.frame(delta=delta.vals)

lines(delta.vals, predict(lo.center, newdata), lwd=4)
lines(delta.vals, predict(lo.upper, newdata), col="darkgray", lwd=2)
lines(delta.vals, predict(lo.lower, newdata), col="darkgray", lwd=2)
dev.off()
